{
    "$graph": [
        {
            "class": "Workflow",
            "label": "Subworkflow to allow calling cnvkit with cram instead of bam files",
            "inputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/access"
                },
                {
                    "type": "File",
                    "id": "#main/bait_intervals"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#main/diagram"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#main/drop_low_coverage"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#main/method"
                },
                {
                    "type": "File",
                    "id": "#main/normal_cram"
                },
                {
                    "type": "string",
                    "id": "#main/reference"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#main/scatter_plot"
                },
                {
                    "type": "File",
                    "id": "#main/tumor_cram"
                }
            ],
            "steps": [
                {
                    "run": "#cram_to_bam.cwl",
                    "in": [
                        {
                            "source": "#main/normal_cram",
                            "id": "#main/normal_cram_to_bam/cram"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/normal_cram_to_bam/reference"
                        }
                    ],
                    "out": [
                        "#main/normal_cram_to_bam/bam"
                    ],
                    "id": "#main/normal_cram_to_bam"
                },
                {
                    "run": "#cnvkit_batch.cwl",
                    "in": [
                        {
                            "source": "#main/access",
                            "id": "#main/run_cnvkit/access"
                        },
                        {
                            "source": "#main/bait_intervals",
                            "id": "#main/run_cnvkit/bait_intervals"
                        },
                        {
                            "source": "#main/diagram",
                            "id": "#main/run_cnvkit/diagram"
                        },
                        {
                            "source": "#main/drop_low_coverage",
                            "id": "#main/run_cnvkit/drop_low_coverage"
                        },
                        {
                            "source": "#main/method",
                            "id": "#main/run_cnvkit/method"
                        },
                        {
                            "source": "#main/normal_cram_to_bam/bam",
                            "id": "#main/run_cnvkit/normal_bam"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/run_cnvkit/reference"
                        },
                        {
                            "source": "#main/scatter_plot",
                            "id": "#main/run_cnvkit/scatter_plot"
                        },
                        {
                            "source": "#main/tumor_cram_to_bam/bam",
                            "id": "#main/run_cnvkit/tumor_bam"
                        }
                    ],
                    "out": [
                        "#main/run_cnvkit/intervals_antitarget",
                        "#main/run_cnvkit/intervals_target",
                        "#main/run_cnvkit/normal_antitarget_coverage",
                        "#main/run_cnvkit/normal_target_coverage",
                        "#main/run_cnvkit/reference_coverage",
                        "#main/run_cnvkit/cn_diagram",
                        "#main/run_cnvkit/cn_scatter_plot",
                        "#main/run_cnvkit/tumor_antitarget_coverage",
                        "#main/run_cnvkit/tumor_target_coverage",
                        "#main/run_cnvkit/tumor_bin_level_ratios",
                        "#main/run_cnvkit/tumor_segmented_ratios"
                    ],
                    "id": "#main/run_cnvkit"
                },
                {
                    "run": "#cram_to_bam.cwl",
                    "in": [
                        {
                            "source": "#main/tumor_cram",
                            "id": "#main/tumor_cram_to_bam/cram"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/tumor_cram_to_bam/reference"
                        }
                    ],
                    "out": [
                        "#main/tumor_cram_to_bam/bam"
                    ],
                    "id": "#main/tumor_cram_to_bam"
                }
            ],
            "id": "#main",
            "outputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#main/run_cnvkit/cn_diagram",
                    "id": "#main/cn_diagram"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#main/run_cnvkit/cn_scatter_plot",
                    "id": "#main/cn_scatter_plot"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#main/run_cnvkit/intervals_antitarget",
                    "id": "#main/intervals_antitarget"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#main/run_cnvkit/intervals_target",
                    "id": "#main/intervals_target"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_cnvkit/normal_antitarget_coverage",
                    "id": "#main/normal_antitarget_coverage"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_cnvkit/normal_target_coverage",
                    "id": "#main/normal_target_coverage"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#main/run_cnvkit/reference_coverage",
                    "id": "#main/reference_coverage"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_cnvkit/tumor_antitarget_coverage",
                    "id": "#main/tumor_antitarget_coverage"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_cnvkit/tumor_bin_level_ratios",
                    "id": "#main/tumor_bin_level_ratios"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_cnvkit/tumor_segmented_ratios",
                    "id": "#main/tumor_segmented_ratios"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_cnvkit/tumor_target_coverage",
                    "id": "#main/tumor_target_coverage"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "/usr/bin/python",
                "/usr/local/bin/cnvkit.py",
                "batch"
            ],
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "etal/cnvkit:0.9.5"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "ramMin": 4000,
                    "tmpdirMin": 10000
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 5,
                        "prefix": "--access"
                    },
                    "id": "#cnvkit_batch.cwl/access"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--targets"
                    },
                    "id": "#cnvkit_batch.cwl/bait_intervals"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 7,
                        "prefix": "--diagram"
                    },
                    "id": "#cnvkit_batch.cwl/diagram"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 10,
                        "prefix": "--drop-low-coverage"
                    },
                    "id": "#cnvkit_batch.cwl/drop_low_coverage"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-y"
                    },
                    "id": "#cnvkit_batch.cwl/male_reference"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "hybrid",
                    "inputBinding": {
                        "position": 6,
                        "prefix": "--method"
                    },
                    "id": "#cnvkit_batch.cwl/method"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--normal"
                    },
                    "id": "#cnvkit_batch.cwl/normal_bam"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 4,
                        "prefix": "--fasta"
                    },
                    "id": "#cnvkit_batch.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-r"
                    },
                    "id": "#cnvkit_batch.cwl/reference_cnn"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 8,
                        "prefix": "--scatter"
                    },
                    "id": "#cnvkit_batch.cwl/scatter_plot"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#cnvkit_batch.cwl/tumor_bam"
                }
            ],
            "outputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.tumor_bam.nameroot)-diagram.pdf"
                    },
                    "id": "#cnvkit_batch.cwl/cn_diagram"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.tumor_bam.nameroot)-scatter.pdf"
                    },
                    "id": "#cnvkit_batch.cwl/cn_scatter_plot"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${  \n    var glob_base = \".antitarget.bed\";\n    if (inputs.bait_intervals) {\n        glob_base = inputs.bait_intervals.nameroot + glob_base;\n    }   \n    return glob_base;\n}  \n"
                    },
                    "id": "#cnvkit_batch.cwl/intervals_antitarget"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${\n    var glob_base = \".target.bed\";\n    if (inputs.bait_intervals) {\n        glob_base = inputs.bait_intervals.nameroot + glob_base;\n    }\n    return glob_base;\n}\n"
                    },
                    "id": "#cnvkit_batch.cwl/intervals_target"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${\n    var glob_base = \".antitargetcoverage.cnn\";\n    if (inputs.normal_bam) {\n        glob_base = inputs.normal_bam.nameroot + glob_base;\n    }\n    return glob_base;\n}\n"
                    },
                    "id": "#cnvkit_batch.cwl/normal_antitarget_coverage"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${\n    var glob_base = \".targetcoverage.cnn\";\n    if (inputs.normal_bam) {\n        glob_base = inputs.normal_bam.nameroot + glob_base;\n    }\n    return glob_base;\n}\n"
                    },
                    "id": "#cnvkit_batch.cwl/normal_target_coverage"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "reference.cnn"
                    },
                    "id": "#cnvkit_batch.cwl/reference_coverage"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.tumor_bam.nameroot).antitargetcoverage.cnn"
                    },
                    "id": "#cnvkit_batch.cwl/tumor_antitarget_coverage"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.tumor_bam.nameroot).cnr"
                    },
                    "id": "#cnvkit_batch.cwl/tumor_bin_level_ratios"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.tumor_bam.nameroot).cns"
                    },
                    "id": "#cnvkit_batch.cwl/tumor_segmented_ratios"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.tumor_bam.nameroot).targetcoverage.cnn"
                    },
                    "id": "#cnvkit_batch.cwl/tumor_target_coverage"
                }
            ],
            "id": "#cnvkit_batch.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "samtools view cram to bam",
            "baseCommand": [
                "/opt/samtools/bin/samtools",
                "view",
                "-b"
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/samtools-cwl:1.0.0"
                }
            ],
            "arguments": [
                "-o",
                {
                    "valueFrom": "$(runtime.outdir)/$(inputs.cram.nameroot).bam"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "secondaryFiles": [
                        "^.crai"
                    ],
                    "id": "#cram_to_bam.cwl/cram"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "-T",
                        "position": 1
                    },
                    "id": "#cram_to_bam.cwl/reference"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.cram.nameroot).bam"
                    },
                    "id": "#cram_to_bam.cwl/bam"
                }
            ],
            "id": "#cram_to_bam.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
